from .utils.utils import INV_SQRT2 as INV_SQRT2, SQRT2 as SQRT2
from _typeshed import Incomplete
from pyvqnet.dtype import C_DTYPE as C_DTYPE, D_DTYPE as D_DTYPE, F_DTYPE as F_DTYPE, Z_DTYPE as Z_DTYPE, get_readable_dtype_str as get_readable_dtype_str, kcomplex128 as kcomplex128, kcomplex64 as kcomplex64, kfloat32 as kfloat32, kfloat64 as kfloat64
from pyvqnet.tensor import QTensor as QTensor, tensor as tensor

def FLOAT_2_COMPLEX(param): ...
def COMPLEX_2_FLOAT(param): ...
def rx_matrix(params): ...
def rz_matrix(params):
    """Compute unitary matrix for rz gate.

    Args:
        params: The rotation angle.

    Returns:
        The computed unitary matrix.

    """
def ry_matrix(params): ...
def rxx_matrix(params): ...
def ryy_matrix(params): ...
def rzz_matrix(params): ...
def rzx_matrix(params): ...
def u1_matrix(params): ...
def u2_matrix(params): ...
def u3_matrix(params): ...
def rot_matrix(params): ...
def cu1_matrix(params): ...
def iswap_matrix(params): ...
def basic_state_projector_matrix(basis_state): ...
def isingxx_matrix(params): ...
def isingyy_matrix(params): ...
def isingzz_matrix(params): ...
def isingxy_matrix(params): ...
def phaseshift_matrix(params): ...
def pauli_eigs(n): ...
def multirz_matrix(params, n_wires): ...
def controlledphaseshift_matrix(params): ...
def multicnot_matrix(n_wires): ...
def multixcnot_matrix(n_wires): ...
def single_excitation_matrix(params): ...
def double_excitation_matrix(phi): ...
def crx_matrix(params):
    """Compute unitary matrix for CRX gate.

.. math::

        \x08egin{align}
            CR_y(\\phi) &=
            \x08egin{bmatrix}
                1 & 0 & 0 & 0 \\\n                0 & 1 & 0 & 0\\\n                0 & 0 & \\cos(\\phi/2) & -\\sin(\\phi/2)\\\n                0 & 0 & \\sin(\\phi/2) & \\cos(\\phi/2)
            \\end{bmatrix}.
        \\end{align}
    """
def cry_matrix(params):
    """Compute unitary matrix for CRY gate.

    .. math::

            \x08egin{align}
                CR_y(\\phi) &=
                \x08egin{bmatrix}
                    1 & 0 & 0 & 0 \\\n                    0 & 1 & 0 & 0\\\n                    0 & 0 & \\cos(\\phi/2) & -\\sin(\\phi/2)\\\n                    0 & 0 & \\sin(\\phi/2) & \\cos(\\phi/2)
                \\end{bmatrix}.
            \\end{align}

    """
def crot_matrix(params):
    """Compute unitary matrix for CRot gate.


    """
def crz_matrix(params):
    """Compute unitary matrix for CRZ gate.

    .. math::

        \x08egin{align}
             CR_z(\\phi) &=
             \x08egin{bmatrix}
                1 & 0 & 0 & 0 \\\n                0 & 1 & 0 & 0\\\n                0 & 0 & e^{-i\\phi/2} & 0\\\n                0 & 0 & 0 & e^{i\\phi/2}
            \\end{bmatrix}.
        \\end{align}

    """

double_mat_dict: Incomplete
float_mat_dict: Incomplete
